<script>

  import {select} from 'd3-selection';
  import {axisBottom, axisLeft} from 'd3-axis';
  import {scaleLinear, scaleBand} from 'd3-scale';
  
  
  const width = 600;
  const height = 300;
  const margin = { top: 10, right: 10, bottom: 30, left: 60 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  
  // Array
  const data = [
    { service: "Netflix", viewers: 2.9 },
    { service: "Amazon Prime Video", viewers: 1.3 },
    { service: "Disney+", viewers: 2.1 },
    { service: "Hulu", viewers: 0.9 },
    { service: "Apple TV", viewers: 1.1 },
    { service: "Rakuten", viewers: 0.4 }
  ];
  
  const service_class = data.map(data_values=>data_values.service);
  // scales
  const scaleX = scaleBand().range([0,innerWidth]).domain(service_class);
  const scaleY=scaleLinear().domain([0,3]).range([innerHeight,0]);
  // axes
  function xAxis(g){const xAxis = axisBottom(scaleX); xAxis(select(g))}
  function yAxis(g){const yAxis = axisLeft(scaleY); yAxis(select(g))}
  
  
  </script>
  
  <svg viewbox="0 0 {width} {height}" style="max-width: {width}px">
      
    <g transform={"translate(${margin.left},${margin.top})"}>
      {#each data as datapoint}
        <rect x={scaleX(datapoint.service)+70} 
              y={scaleY(datapoint.viewers)+margin.top} 
              width="60" 
              height={innerHeight-scaleY(+datapoint.viewers)} 
              fill="steelblue"/>
      {/each}
    </g>
    <g transform="translate({margin.left},{margin.top})" use:yAxis></g>
    <g transform="translate({margin.left},{innerHeight+margin.top})" use:xAxis></g>
    <text x={innerWidth/2} y={innerHeight/2-innerWidth/2-10} 
				transform="rotate(270, {width/2},{innerHeight/2})"
				font-size="12">
		Viewers (Million)  
	</text>
  </svg>
  
  
  